"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.HooksManager = void 0;
const hook_1 = require("./hook");
class HooksManagerClass {
    constructor() {
        //
        // Protected properties.
        this._hooks = {};
    }
    //
    // Public methods.
    get(key) {
        // istanbul ignore else
        if (this._hooks[key] === undefined) {
            this._hooks[key] = new hook_1.Hook(key);
        }
        return this._hooks[key];
    }
    keys() {
        return Object.keys(this._hooks);
    }
    //
    // Public class methods.
    static Instance() {
        // istanbul ignore else
        if (!HooksManagerClass._Instance) {
            HooksManagerClass._Instance = new HooksManagerClass();
        }
        return HooksManagerClass._Instance;
    }
}
//
// Protected class properties.
HooksManagerClass._Instance = null;
exports.HooksManager = HooksManagerClass.Instance();
