"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.KoaResponseBuilder = void 0;
const drcollector_1 = require("../drcollector");
const includes_1 = require("../includes");
class KoaResponseBuilder {
    //
    // Constructor.
    // istanbul ignore next
    constructor() {
        throw new Error(`This class is just a factory, no instances can be created.`);
    }
    //
    // Public class methods.
    static ConfigContents(managerKey, name) {
        let result = {};
        const managers = drcollector_1.DRCollector.configsManagers();
        let manager = null;
        for (const m of managers) {
            if (m.matchesKey(managerKey)) {
                manager = m;
                break;
            }
        }
        if (manager) {
            let item = null;
            const items = manager.items();
            for (const key of Object.keys(items)) {
                if (key === name) {
                    item = items[key];
                }
            }
            if (item) {
                result = includes_1.Tools.DeepCopy(item);
                result.contents = manager.get(item.name);
            }
        }
        return result;
    }
    static ConfigSpecsContents(managerKey, name) {
        let result = {};
        const managers = drcollector_1.DRCollector.configsManagers();
        let manager = null;
        for (const m of managers) {
            if (m.matchesKey(managerKey)) {
                manager = m;
                break;
            }
        }
        if (manager) {
            let item = null;
            const items = manager.specs();
            for (const key of Object.keys(items)) {
                if (key === name) {
                    item = items[key];
                }
            }
            if (item) {
                result = includes_1.Tools.DeepCopy(item);
                result.contents = manager.getSpecs(item.name);
            }
        }
        return result;
    }
    static FullInfoResponse() {
        return drcollector_1.DRCollector.infoReport();
    }
}
exports.KoaResponseBuilder = KoaResponseBuilder;
