/// <reference types="node" />
/**
 * @file manager.ts
 * @author Alejandro D. Simi
 */
import { ConfigsManager } from '../configs';
import { GenericManager } from '../includes';
import { ITasksManagerOptions, ITasksManager_TasksResponse, TasksList } from '.';
export declare class TasksManager extends GenericManager<ITasksManagerOptions> {
    protected _consumingQueue: boolean;
    protected _intervals: NodeJS.Timeout[];
    protected _items: TasksList | null;
    protected _paused: string[];
    protected _queue: any[];
    protected _queueInterval: NodeJS.Timeout | null;
    protected _stopped: boolean;
    protected _shutDown: boolean;
    constructor(directories: string[] | string, options?: ITasksManagerOptions | null, configs?: ConfigsManager | null);
    isShutDown(): boolean;
    load(): Promise<boolean>;
    pause(key: string): void;
    paused(): string[];
    tasks(): ITasksManager_TasksResponse[];
    shutDown(): void;
    stop(): void;
    stopped(): boolean;
    unpause(key: string): void;
    unstop(): void;
    protected consumeQueue(): Promise<void>;
    protected cleanOptions(): void;
    protected runAtStart(): Promise<void>;
    protected setIntervals(): void;
}
