/**
 * @file task.ts
 * @author Alejandro D. Simi
 */
import { ConfigsManager } from '../configs';
import { TasksManager } from '.';
export declare abstract class Task {
    protected _configs: ConfigsManager | null;
    protected _coreName: string;
    protected _manager: TasksManager | null;
    protected _overloads: number;
    protected canOverload: boolean;
    protected interval: number;
    protected runAtStart: boolean;
    constructor();
    code(): string;
    coreRun(): Promise<void>;
    description(): string | null;
    getInterval(): number;
    abstract name(): string;
    paused(): boolean;
    abstract run(): Promise<void>;
    running(): boolean;
    setConfigs(configs: ConfigsManager | null): void;
    setCoreName(coreName: string): void;
    setManager(manager: TasksManager): void;
    shouldRunAtStart(): boolean;
    protected coreShouldRun(): Promise<boolean>;
    protected load(): void;
    protected shouldRun(): Promise<boolean>;
}
